/*
-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA1

  m m mm mmm .----------.  .---------------------. mmm mm m m
  8 8 88 888 | .--------`  |  .------------------` 888 88 8 8
  8 8 88 888 | ```````|`V```````|   |``||``|`````| 888 88 8 8
  8 8 88 888 `------  | |  [] | |``````||  |  [] | 888 88 8 8
  8 8 88 888 |``````  | |     | ````|````  |     | 888 88 8 8
  ` ` `` ``` ``````````````>  |````````````|   |`` ``` `` ` `
                ==============`            `---`
                                 L A B O R A T O R I E S
  
This file is part of Hacker Radio Rec.
  
Hacker Radio Rec is free software: you can redistribute it and/or
modify it under the terms of the GNU General Public License as
published by the Free Software Foundation, either version 3 of
the License or (at your option) any later version.

Hacker Radio Rec is distributed in the hope that it will be
useful, but WITHOUT ANY WARRANTY; without even the implied
warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
See the GNU General Public License for more details.

               Copyright (C) 2009, Thea DeSilva
  You can find a copy of GNU General Public License in COPYING
*/
#include <stdio.h>
#include <stdlib.h>
#include "config.h"
#include <pthread.h>
#include <SDL.h>
#include "gui_types.h"
#include "link.h"
#include "drop.h"
#include "gui.h"
#include "draw.h"
#include "std_dialog.h"
#include "font.h"
#include "pixel.h"

#include "../not/libnot.h"

unsigned char *font;

void draw_char(Sint32 x, Sint32 y, char c, Sint32 fg_color, Sint32 bg_color, Sint32 flags) {
 Sint32 s,t,j;
 unsigned char *src;
 unsigned char *pix, *actual;

 if( (x+current_grp->pos_x) < 0) return;
 if( (x+current_grp->pos_x) > gc->w-8) return;
 if( (y+current_grp->pos_y) < 0) return;
 if( (y+current_grp->pos_y) > gc->h-8) return;
 actual = (unsigned char *)((void *)gc->pixels+
  (((x+current_grp->pos_x)*gc->format->BytesPerPixel)+
   ((y+current_grp->pos_y)*gc->pitch))); 
 for(t = 0;t<8;t++)
  for(s = 0;s<8;s++) 
   if( (font[ ((c-0x20) * 8)+t]>>(8-s)) &1 ==1 ) {
    if(CHECK_FLAG(flags, NO_HASH)==TRUE)
     src = (unsigned char *)&fg_color;
    else {
     if( (c^t)&1 == 1 )
      src = (unsigned char *)&fg_color;
     else
      src = (unsigned char *)&bg_color;
    }
    pix = &actual[(t * gc->pitch)+ (s * gc->format->BytesPerPixel)];  
#ifdef WORDS_BIGENDIAN
    BIG_PIXEL_DOWN_24_STATIC;
#else
    LITTLE_PIXEL_DOWN_24_STATIC;
#endif
   }
}

void draw_text(Sint32 x,Sint32 y, char *in, color_t *fg, color_t *bg, Sint32 flags, Sint32 max) {
 Sint32 i;
 Sint32 fg_color;
 Sint32 bg_color;
 char terminal;
// if(pthread_self() != host_thread) 
//  printf("Incorrect thread drawing stuff:%s\n", in);


 fg_color = SDL_MapRGB(gc->format, fg->r, fg->g, fg->b);
 bg_color = SDL_MapRGB(gc->format, bg->r, bg->g, bg->b);

 if(CHECK_FLAG(flags, CR_TERMINAL) == TRUE) 
  terminal = '\n';
 else
  terminal = 0;

 LOCK;
 for(i=0;i<strlen(in);i++) {
  if(in[i] == terminal) break;
  if(CHECK_FLAG(flags, MAX_CHARS) == TRUE)
   if(i > max) break;
  draw_char( x+ (i*8), y, in[i],fg_color, bg_color, flags);
 }
 UNLOCK;
 globl_dirt = 1;
}

/* fonts 0x20 - 0x7f */

unsigned char default_font[] = { 
 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
 0x18, 0x3C, 0x3C, 0x18, 0x18, 0x00, 0x18, 0x00,
 0x6C, 0x6C, 0x6C, 0x00, 0x00, 0x00, 0x00, 0x00,
 0x6C, 0x6C, 0xFE, 0x6C, 0xFE, 0x6C, 0x6C, 0x00,
 0x18, 0x7E, 0xC0, 0x7C, 0x06, 0xFC, 0x18, 0x00,
 0x00, 0xC6, 0xCC, 0x18, 0x30, 0x66, 0xC6, 0x00,
 0x38, 0x6C, 0x38, 0x76, 0xDC, 0xCC, 0x76, 0x00,
 0x30, 0x30, 0x60, 0x00, 0x00, 0x00, 0x00, 0x00,
 0x18, 0x30, 0x60, 0x60, 0x60, 0x30, 0x18, 0x00,
 0x60, 0x30, 0x18, 0x18, 0x18, 0x30, 0x60, 0x00,
 0x00, 0x66, 0x3C, 0xFF, 0x3C, 0x66, 0x00, 0x00,
 0x00, 0x18, 0x18, 0x7E, 0x18, 0x18, 0x00, 0x00,
 0x00, 0x00, 0x00, 0x00, 0x00, 0x18, 0x18, 0x30,
 0x00, 0x00, 0x00, 0x7E, 0x00, 0x00, 0x00, 0x00,
 0x00, 0x00, 0x00, 0x00, 0x00, 0x18, 0x18, 0x00,
 0x06, 0x0C, 0x18, 0x30, 0x60, 0xC0, 0x80, 0x00,
 0x7C, 0xCE, 0xDE, 0xF6, 0xE6, 0xC6, 0x7C, 0x00,
 0x30, 0x70, 0x30, 0x30, 0x30, 0x30, 0xFC, 0x00,
 0x78, 0xCC, 0x0C, 0x38, 0x60, 0xCC, 0xFC, 0x00,
 0x78, 0xCC, 0x0C, 0x38, 0x0C, 0xCC, 0x78, 0x00,
 0x1C, 0x3C, 0x6C, 0xCC, 0xFE, 0x0C, 0x1E, 0x00,
 0xFC, 0xC0, 0xF8, 0x0C, 0x0C, 0xCC, 0x78, 0x00,
 0x38, 0x60, 0xC0, 0xF8, 0xCC, 0xCC, 0x78, 0x00,
 0xFC, 0xCC, 0x0C, 0x18, 0x30, 0x30, 0x30, 0x00,
 0x78, 0xCC, 0xCC, 0x78, 0xCC, 0xCC, 0x78, 0x00,
 0x78, 0xCC, 0xCC, 0x7C, 0x0C, 0x18, 0x70, 0x00,
 0x00, 0x18, 0x18, 0x00, 0x00, 0x18, 0x18, 0x00,
 0x00, 0x18, 0x18, 0x00, 0x00, 0x18, 0x18, 0x30,
 0x18, 0x30, 0x60, 0xC0, 0x60, 0x30, 0x18, 0x00,
 0x00, 0x00, 0x7E, 0x00, 0x7E, 0x00, 0x00, 0x00,
 0x60, 0x30, 0x18, 0x0C, 0x18, 0x30, 0x60, 0x00,
 0x3C, 0x66, 0x0C, 0x18, 0x18, 0x00, 0x18, 0x00,
 0x7C, 0xC6, 0xDE, 0xDE, 0xDC, 0xC0, 0x7C, 0x00,
 0x30, 0x78, 0xCC, 0xCC, 0xFC, 0xCC, 0xCC, 0x00,
 0xFC, 0x66, 0x66, 0x7C, 0x66, 0x66, 0xFC, 0x00,
 0x3C, 0x66, 0xC0, 0xC0, 0xC0, 0x66, 0x3C, 0x00,
 0xF8, 0x6C, 0x66, 0x66, 0x66, 0x6C, 0xF8, 0x00,
 0xFE, 0x62, 0x68, 0x78, 0x68, 0x62, 0xFE, 0x00,
 0xFE, 0x62, 0x68, 0x78, 0x68, 0x60, 0xF0, 0x00,
 0x3C, 0x66, 0xC0, 0xC0, 0xCE, 0x66, 0x3A, 0x00,
 0xCC, 0xCC, 0xCC, 0xFC, 0xCC, 0xCC, 0xCC, 0x00,
 0x78, 0x30, 0x30, 0x30, 0x30, 0x30, 0x78, 0x00,
 0x1E, 0x0C, 0x0C, 0x0C, 0xCC, 0xCC, 0x78, 0x00,
 0xE6, 0x66, 0x6C, 0x78, 0x6C, 0x66, 0xE6, 0x00,
 0xF0, 0x60, 0x60, 0x60, 0x62, 0x66, 0xFE, 0x00,
 0xC6, 0xEE, 0xFE, 0xFE, 0xD6, 0xC6, 0xC6, 0x00,
 0xC6, 0xE6, 0xF6, 0xDE, 0xCE, 0xC6, 0xC6, 0x00,
 0x38, 0x6C, 0xC6, 0xC6, 0xC6, 0x6C, 0x38, 0x00,
 0xFC, 0x66, 0x66, 0x7C, 0x60, 0x60, 0xF0, 0x00,
 0x7C, 0xC6, 0xC6, 0xC6, 0xD6, 0x7C, 0x0E, 0x00,
 0xFC, 0x66, 0x66, 0x7C, 0x6C, 0x66, 0xE6, 0x00,
 0x7C, 0xC6, 0xE0, 0x78, 0x0E, 0xC6, 0x7C, 0x00,
 0xFC, 0xB4, 0x30, 0x30, 0x30, 0x30, 0x78, 0x00,
 0xCC, 0xCC, 0xCC, 0xCC, 0xCC, 0xCC, 0xFC, 0x00,
 0xCC, 0xCC, 0xCC, 0xCC, 0xCC, 0x78, 0x30, 0x00,
 0xC6, 0xC6, 0xC6, 0xC6, 0xD6, 0xFE, 0x6C, 0x00,
 0xC6, 0xC6, 0x6C, 0x38, 0x6C, 0xC6, 0xC6, 0x00,
 0xCC, 0xCC, 0xCC, 0x78, 0x30, 0x30, 0x78, 0x00,
 0xFE, 0xC6, 0x8C, 0x18, 0x32, 0x66, 0xFE, 0x00,
 0x78, 0x60, 0x60, 0x60, 0x60, 0x60, 0x78, 0x00,
 0xC0, 0x60, 0x30, 0x18, 0x0C, 0x06, 0x02, 0x00,
 0x78, 0x18, 0x18, 0x18, 0x18, 0x18, 0x78, 0x00,
 0x10, 0x38, 0x6C, 0xC6, 0x00, 0x00, 0x00, 0x00,
 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xFF,
 0x30, 0x30, 0x18, 0x00, 0x00, 0x00, 0x00, 0x00,
 0x00, 0x00, 0x78, 0x0C, 0x7C, 0xCC, 0x76, 0x00,
 0xE0, 0x60, 0x60, 0x7C, 0x66, 0x66, 0xDC, 0x00,
 0x00, 0x00, 0x78, 0xCC, 0xC0, 0xCC, 0x78, 0x00,
 0x1C, 0x0C, 0x0C, 0x7C, 0xCC, 0xCC, 0x76, 0x00,
 0x00, 0x00, 0x78, 0xCC, 0xFC, 0xC0, 0x78, 0x00,
 0x38, 0x6C, 0x64, 0xF0, 0x60, 0x60, 0xF0, 0x00,
 0x00, 0x00, 0x76, 0xCC, 0xCC, 0x7C, 0x0C, 0xF8,
 0xE0, 0x60, 0x6C, 0x76, 0x66, 0x66, 0xE6, 0x00,
 0x30, 0x00, 0x70, 0x30, 0x30, 0x30, 0x78, 0x00,
 0x0C, 0x00, 0x1C, 0x0C, 0x0C, 0xCC, 0xCC, 0x78,
 0xE0, 0x60, 0x66, 0x6C, 0x78, 0x6C, 0xE6, 0x00,
 0x70, 0x30, 0x30, 0x30, 0x30, 0x30, 0x78, 0x00,
 0x00, 0x00, 0xCC, 0xFE, 0xFE, 0xD6, 0xD6, 0x00,
 0x00, 0x00, 0xB8, 0xCC, 0xCC, 0xCC, 0xCC, 0x00,
 0x00, 0x00, 0x78, 0xCC, 0xCC, 0xCC, 0x78, 0x00,
 0x00, 0x00, 0xDC, 0x66, 0x66, 0x7C, 0x60, 0xF0,
 0x00, 0x00, 0x76, 0xCC, 0xCC, 0x7C, 0x0C, 0x1E,
 0x00, 0x00, 0xDC, 0x76, 0x62, 0x60, 0xF0, 0x00,
 0x00, 0x00, 0x7C, 0xC0, 0x70, 0x1C, 0xF8, 0x00,
 0x10, 0x30, 0xFC, 0x30, 0x30, 0x34, 0x18, 0x00,
 0x00, 0x00, 0xCC, 0xCC, 0xCC, 0xCC, 0x76, 0x00,
 0x00, 0x00, 0xCC, 0xCC, 0xCC, 0x78, 0x30, 0x00,
 0x00, 0x00, 0xC6, 0xC6, 0xD6, 0xFE, 0x6C, 0x00,
 0x00, 0x00, 0xC6, 0x6C, 0x38, 0x6C, 0xC6, 0x00,
 0x00, 0x00, 0xCC, 0xCC, 0xCC, 0x7C, 0x0C, 0xF8,
 0x00, 0x00, 0xFC, 0x98, 0x30, 0x64, 0xFC, 0x00,
 0x1C, 0x30, 0x30, 0xE0, 0x30, 0x30, 0x1C, 0x00,
 0x18, 0x18, 0x18, 0x00, 0x18, 0x18, 0x18, 0x00,
 0xE0, 0x30, 0x30, 0x1C, 0x30, 0x30, 0xE0, 0x00,
 0x76, 0xDC, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
 0x00, 0x10, 0x38, 0x6C, 0xC6, 0xC6, 0xFE, 0x00
};
/*
  Thank you for your attention
-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.4.9 (OpenBSD)

iEYEARECAAYFAkrsgv0ACgkQMNO4A6bnBrOl+QCfQsaajSFcg0lqDRb1rEUND0m4
ZKMAn2T2ifl8Qp8LSoJLE8uNf2m5EOs9
=OHja
-----END PGP SIGNATURE-----
*/
